#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

struct Vrchol
{
	vector<int> next;
	int f;
};

int main()
{
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
	int n, m;
	scanf("%d %d", &n, &m);
	vector<pair<pair<int, int>,bool> > hrany;
	for(int i = 0; i < m; i++)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		hrany.push_back(make_pair(make_pair(a-1, b-1), true));
	}
	int k;
	scanf("%d", &k);
	vector<int> s;
	s.resize(k);
	for(int i = 0; i < k; i++)
	{
		scanf("%d", &s[i]);
		s[i]--;
		hrany[s[i]].second = false;
	}
	vector<Vrchol> v;
	v.resize(n);
	for(int i = 0; i < m; i++)
	{
		if(hrany[i].second==false) continue;
		v[hrany[i].first.first].next.push_back(hrany[i].first.second);
		v[hrany[i].first.second].next.push_back(hrany[i].first.first);
	}
	for(int i = 0; i < n; i++)
		v[i].f = -1;
	int cf = 0;
	int cv = 0;
	while(1){
		while(cv < n && v[cv].f != -1) cv++;
		if(cv==n) break;
		queue<int> fr;
		fr.push(cv);
		v[cv].f = cf;
		while(!fr.empty())
		{
			int x = fr.front(); fr.pop();
			for(int i = 0; i < v[x].next.size(); i++)
			{
				if(v[v[x].next[i]].f!=-1) continue;
				v[v[x].next[i]].f = cf;
				fr.push(v[x].next[i]);
			}
		}		
		cf++;
	}
	vector<int> result;
	result.push_back(cf);
	for(int i = k-1; i >= 0; i--){
		if(v[hrany[s[i]].first.first].f != v[hrany[s[i]].first.second].f)
		{
			cf--;
			int a = v[hrany[s[i]].first.first].f;
			int b = v[hrany[s[i]].first.second].f;
			for(int j = 0; j < n; j++)
				if(v[j].f==b) v[j].f=a;
		}
		result.push_back(cf);
	}
	for(int i = result.size()-1; i >= 0; i--){
		printf("%d\n", result[i]-1);
	}
}

