// another fine solution by misof
#include <vector>
#include <queue>
#include <cstdio>
using namespace std;

#define MAX 1234567

int N, M, K;
int E[MAX][3];
int D[MAX];
vector< vector<int> > G;

int main() {
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
  scanf("%d%d",&N,&M);
  G.resize(N+1);
  for (int m=1; m<=M; ++m) { 
    scanf("%d%d",&E[m][0],&E[m][1]); 
    E[m][2]=M+1; 
    G[ E[m][0] ].push_back(m); 
    G[ E[m][1] ].push_back(m); 
  }
  scanf("%d",&K);
  for (int k=1; k<=K; ++k) {
    scanf("%d",&D[k]); 
    E[D[k]][2]=k; 
  }
  
  int components = 0;
  int uz[N+1];
  for (int a=1; a<=N; ++a) uz[a]=0;
  for (int a=1; a<=N; ++a) if (!uz[a]) {
    ++components;
    queue<int> Q;
    Q.push(a);
    uz[a] = 1;
    while (!Q.empty()) {
      int kde = Q.front(); Q.pop();
      for (int i=0; i<int(G[kde].size()); ++i) {
        int e = G[kde][i];
        int kam = E[e][0] + E[e][1] - kde;
        if (uz[kam]) continue;
        uz[kam] = 1;
        Q.push(kam);
      }
    }
  }
  printf("%d\n",components-1);

  for (int k=1; k<=K; ++k) {
    int zac=E[D[k]][0], kon=E[D[k]][1];
    for (int a=1; a<=N; ++a) uz[a]=0;
    queue<int> Q;
    Q.push(zac);
    bool done = false;
    while (!Q.empty()) {
      int kde = Q.front(); Q.pop();
      for (int i=0; i<int(G[kde].size()); ++i) {
        int e = G[kde][i];
        if (E[e][2] <= k) continue;
        int kam = E[e][0] + E[e][1] - kde;
        if (uz[kam]) continue;
        uz[kam] = 1;
        Q.push(kam);
        if (kam == kon) done = true;
      }
      if (done) break;
    }
    if (!uz[kon]) ++components;
    printf("%d\n",components-1);
  }
}
